/*
//
// S-38.3610 Network Programming (Spring 2013)
// Assignment 2: HTTP Server
// Filip Nybck (79808K)
//
*/

//standard C headers
#include <ctype.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>

//local headers
#include "string.h"
#include "threads.h"

/**
 * Compare at most max_len characters of strings s1 and s1 case insensitively.
 */
int strnicmp(const char *s1, const char *s2, size_t max_len)
{
	size_t i;
	
	for(i = 0; i < max_len && s1[i] != '\0' && toupper(s1[i]) == toupper(s2[i]); i++)
		;

	if(i == max_len)
		return 0;
	
	return (int)(unsigned char)s1[i] - (int)(unsigned char)s2[i];
}

/**
 * Compare strings s1 and s1 case insensitively.
 */
int stricmp(const char *s1, const char *s2)
{
	return strnicmp(s1, s2, SIZE_MAX);
}

/**
 * Count the number of characters of s, however, at most max_len characters.
 */
size_t strnlen(const char *s, size_t max_len)
{
	size_t len;

	for(len = 0; s[len] != '\0' && len < max_len; len++) {
	}

	return len;
}

/**
 * Duplicate string s, however, at most max_len characters. This uses the
 * safer_malloc to allocate memory for the new string, so should be thread 
 * safe.
 */
char *strndup(const char *s, size_t max_len)
{
	char *t;
	size_t length;
	
	if(s == NULL)
		return NULL;
	
	length = strnlen(s, max_len);
	
	t = (char *)safer_malloc(length + 1);
	if(t == NULL)
		return NULL;
	
	strncpy(t, s, length);
	t[length] = '\0';
	
	return t;
}

/**
 * Duplicate string s. Not a standard library function. Uses the strndup
 * function above, which, in turn, uses safer_malloc to allocate memory for 
 * the new string, so should be thread safe.
 */
char *strdup(const char *s)
{
	return strndup(s, SIZE_MAX);
}


