/*
//
// S-38.3610 Network Programming (Spring 2013)
// Assignment 2: HTTP Server
// Filip Nybck (79808K)
//
*/

#ifndef THREADS_H
#define THREADS_H

//standard c headers
#include <stdbool.h>

//unix headers
#include <pthread.h>

//network headers
#include <sys/socket.h>

struct THREAD {
	bool reserved;
	pthread_t id;
	struct SERVE_REQUEST_ARGS {
		struct CONFIG *config;
		int client_sock_fd;
		struct sockaddr_storage client_sock_addr;
	} args;
};

bool init_threads(struct CONFIG *config);
void shutdown_threads();
struct THREAD *alloc_thread_struct(struct CONFIG *config);
bool release_thread_struct(struct THREAD *thread);

void *safer_malloc(size_t size);
void safer_free(void *ptr);

#endif //THREADS_H
